'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VerticalPicker = function (_React$Component) {
  _inherits(VerticalPicker, _React$Component);

  function VerticalPicker(props, context) {
    _classCallCheck(this, VerticalPicker);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(VerticalPicker).call(this, props, context));

    _this.scrollSpeed = 2;
    _this.state = {
      lastClickOn: 0, // 0 > picker, 1 > button
      goTo: null,
      dragging: false,
      lastY: 40,
      pos: null,
      loaded: false // position relative to the cursor
    };
    _this.pickerList = null;
    _this.picker = null;
    _this.fontSize = 20;
    _this.selectedItem = 0;
    _this.onMouseDownPicker = _this.onMouseDownPicker.bind(_this);
    _this.onMouseUp = _this.onMouseUp.bind(_this);
    _this.onMouseMove = _this.onMouseMove.bind(_this);
    _this.getPickerListStyle = _this.getPickerListStyle.bind(_this);
    _this.cablibreTopPickerList = _this.cablibreTopPickerList.bind(_this);
    _this.handleOnClickButton = _this.handleOnClickButton.bind(_this);
    _this.handleOnClickDown = _this.handleOnClickDown.bind(_this);
    _this.handleOnClickUp = _this.handleOnClickUp.bind(_this);
    _this.onWheel = _this.onWheel.bind(_this);
    _this.getArrowStyle = _this.getArrowStyle.bind(_this);
    return _this;
  }

  _createClass(VerticalPicker, [{
    key: 'onWheel',
    value: function onWheel(e) {
      this.handleOnClickButton(e, e.deltaY > 0 ? -1 : 1);
    }
  }, {
    key: 'onMouseDownPicker',
    value: function onMouseDownPicker(e) {
      // only left mouse button
      if (e.button !== 0) return;
      var pos = this.pickerList.getBoundingClientRect();
      if (e.pageY > pos.top && e.pageY < pos.bottom && e.pageX > pos.left && e.pageX < pos.right) {
        this.setState({
          lastClickOn: 0,
          dragging: true,
          pos: {
            yDown: e.pageY
          }
        });
        e.stopPropagation();
        e.preventDefault();
      }
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp(e) {
      if (this.state.dragging) {

        var lastY = this.state.lastY ? (this.state.pos.y - this.state.pos.yDown) * this.scrollSpeed + this.state.lastY : (this.state.pos.y - this.state.pos.yDown) * this.scrollSpeed;

        var style = this.getPickerListStyle();
        var selectedItem = -Math.round((-40 + parseInt(style.top)) / 25);

        lastY = 40 - selectedItem * 25;

        this.setState({ dragging: false,
          lastY: lastY ? lastY : this.state.lastY
        });
        e.stopPropagation();
        e.preventDefault();
      }
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(e) {
      if (!this.state.dragging) return;
      this.setState({
        pos: {
          yDown: this.state.pos.yDown,
          y: e.pageY
        }
      });
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('mousemove', this.onMouseMove);
      document.addEventListener('mouseup', this.onMouseUp);
      document.addEventListener('mousedown', this.onMouseDown);
      var ReactDOM = require('react-dom');
      this.pickerList = ReactDOM.findDOMNode(this.refs.pickerList);
      this.picker = ReactDOM.findDOMNode(this.refs.picker);
      this.setState({ loaded: true });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('mousemove', this.onMouseMove);
      document.removeEventListener('mouseup', this.onMouseUp);
      document.removeEventListener('mousedown', this.onMouseDown);
      this.setState({ loaded: false });
    }
  }, {
    key: 'handleOnClickUp',
    value: function handleOnClickUp(e) {
      this.handleOnClickButton(e, 1);
    }
  }, {
    key: 'handleOnClickDown',
    value: function handleOnClickDown(e) {
      this.handleOnClickButton(e, -1);
    }
  }, {
    key: 'handleOnClickButton',
    value: function handleOnClickButton(e, value) {
      if (this.state.lastY) {
        var top = this.cablibreTopPickerList(this.state.lastY + 25 * value);
        this.setState({ goTo: top, lastY: top, lastClickOn: 1 });
      }
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'cablibreTopPickerList',
    value: function cablibreTopPickerList(top) {
      if (top > 40) top = 40;
      if (top < 40 - (this.props.list.length - 1) * 25) top = 40 - (this.props.list.length - 1) * 25;

      return top;
    }
  }, {
    key: 'getPickerListStyle',
    value: function getPickerListStyle() {
      var style = {
        'top': this.state.lastY + "%",
        'transition': 'top .25s'
      };

      if (this.state.goTo && this.state.lastClickOn == 1) {
        var style = {
          'top': this.state.goTo + "%",
          'transition': 'top .25s'
        };
      }

      if (this.state.pos && this.state.pos.y && this.state.pos.yDown) {
        var top = (this.state.pos.y - this.state.pos.yDown) * this.scrollSpeed;
        if (this.state.lastY && this.state.dragging) {
          top += this.state.lastY;
        } else if (this.state.lastY) {
          top = this.state.lastY;
        }
        top = this.cablibreTopPickerList(top);
        style = {
          'top': top + "%"
        };
        if (!this.state.dragging) style = {
          'top': top + "%",
          'transition': 'top .25s'
        };else style = {
          'top': top + "%"
        };
      }
      return style;
    }
  }, {
    key: 'getArrowStyle',
    value: function getArrowStyle() {
      if (this.picker && this.props.arrows) {
        var pickerShape = this.picker.getBoundingClientRect();
        return {
          'color': "red",
          'borderWidth': 11 + "px"
        };
      }
      return {
        'display': 'none'
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var list = [];
      var pickerListStyle = this.getPickerListStyle();
      var selectedItem = -Math.round((-40 + parseInt(pickerListStyle.top)) / 25);
      if (this.props.onSelectedItem && this.selectedItem != selectedItem) {
        this.selectedItem = selectedItem;
        this.props.onSelectedItem(selectedItem);
      }
      var i = 0;
      this.props.list.map(function (item) {
        if (i === selectedItem) list.push(_react2.default.createElement(
          'li',
          { className: 'picker-selected-item', key: i },
          item
        ));else list.push(_react2.default.createElement(
          'li',
          { key: i },
          item
        ));
        i++;
      });

      var classes = "picker-container";
      if (!this.props.isVisible) classes += " hidden";

      return _react2.default.createElement(
        'div',
        { className: classes, onMouseDown: this.onMouseDownPicker },
        _react2.default.createElement(
          'div',
          { className: 'arrow' },
          _react2.default.createElement('div', { onMouseDown: this.handleOnClickUp, style: this.getArrowStyle() })
        ),
        _react2.default.createElement(
          'div',
          { ref: 'picker', onTouchTap: this.handleTouchTap, onWheel: this.onWheel, className: 'picker' },
          _react2.default.createElement('div', { className: 'picker-gradiant-top' }),
          _react2.default.createElement('div', { className: 'picker-gradiant-bottom' }),
          _react2.default.createElement(
            'ul',
            { ref: 'pickerList', className: "picker-list", style: pickerListStyle },
            list
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'arrow' },
          _react2.default.createElement('div', { onMouseDown: this.handleOnClickDown, style: this.getArrowStyle() })
        )
      );
    }
  }]);

  return VerticalPicker;
}(_react2.default.Component);

exports.default = VerticalPicker;